<?php namespace App\Models;

use App\Entities\Procedimento\Procedimento;
use App\Entities\ProcedimentoExame\ProcedimentoExame;
use App\Utils\DateUtils;

class ProcedimentoExameModel extends ModelEntity
{
    protected $table = 'procedimento_exame';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'id_procedimento',
        'id_exame'
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;

    public function registerProcedimentoExame (ProcedimentoExame $procedimento_exame) : void {
        $data = $procedimento_exame->toArray(true);
        $id_procedimento = $this->insert($data);
        $procedimento_exame->setId($id_procedimento);
    }

    public function updateProcedimentoByID (int $id_procedimento, ProcedimentoExame $procedimento_exame) : bool {
        $data = $procedimento_exame->toArray(true);
        $binds = ['id_procedimento' => $id_procedimento];
        $sets = $this->generateUpdateSets($data, $binds);
        $sql = "update procedimento_exame $sets where procedimento.id = :id_procedimento:";
        $query = $this->db->query($sql, $binds);
        return $query->connID->affected_rows === 1;
    }
}
